{************************ ESPAOL *********************************************

  Etiqueta que cambia de color y fuente al situar el ratn sobre el componente.
  Tambin permite definir un control grfico (TImage) con dos imgenes
  que se alternan al entrar y salir el raton de la etiqueta.

  Basado en el cdigo de Jay O'Donnell Oct/97.

  ****************************************************************************
  *Autor :                                                                   *
  *                                                                          *
  *              Carlos Ponce de Len.                                       *
  *              Madrid Febrero 1998.                                        *
  *                                                                          *
  * Creado: 22 de Febrero de 1998                                            *
  *                                                                          *
  * Versin: 2.1                                                             *
  *                                                                          *
  * Historia                                                                 *
  * Versin 2.1  10/03/98  Corrige el bug que hace que despus de un click   *
  *                        el color no cambie.                               *
  *                                                                          *
  * Versin 2.0  22/02/98  Versin inicial freeware                          *
  ****************************************************************************
  //AVISO IMPORTANTE :                                                      //
  //                                                                        //
  //                                                                        //
  //   Este programa es FreeWare                                            //
  //                                                                        //
  //  Por favor, no distribuyas versiones modificadas de este cdigo fuente.//
  //  Si tienes alguna modificacin que crees que debera hacerse, envia-   //
  //  mela a carlosponce@eoi.es y la incluire (despus de verificarla)      //
  //  haciendo mencin a su autor.                                          //
  //                                                                        //
  //  Gracias.                                                              //

  Se han aadido diversas propiedades y mtdos al componente padre (TLabel)

  property ImgControl    : TImage      Control conectado con TEtigraf.
                                       Se cambia la propidad TPicture cuando el
                                       ratn entra (ImagenE) y sale (ImagenS).
                                       Si no se asigna, no ocurre nada.

  property ImagenE       : TPicture    Contenido que se asigna a la propiedad
                                       TPicture del control TImage conectado
                                       (ImgControl) cuando el ratn entra en el
                                       elemento TEtiGraf.

  property ImagenS       : TPicture    Idem, pero cuando el ratn sale.

  Property ColFondoAlEntrar: TColor    Color de fondo del elemento TEtiGraf
                                       cuando el ratn entra. Cuando el ratn
                                       sale, el color mostrado es el indicado
                                       por la propiedad <<Color>>.

  Property FuenteAlEntrar  : TFont     Fuente que se asigna al TEtigraf cuando
                                       el ratn entra. Cuando el ratn
                                       sale, la fuente mostrada es la definida
                                       por la propiedad <<Font>>.

  Property Activa        : Boolean     Indica si el control TEtiGraf debe
                                       responder o no a los movimientos de
                                       entrada y salida del ratn.

***************************** ENGLISH ****************************************
  Label that changes the color and the font when the mouse moves over it.
  Also it's possible to assign a TImage control with two pictures that take turn
  when the mouse moves in & out of the Label.

  Based on the Jay O'Donnell Oct/97 code.

  ****************************************************************************
  *Author :                                                                  *
  *                                                                          *
  *              Carlos Ponce de Len.                                       *
  *              Madrid Febrero 1998.                                        *
  *                                                                          *
  * Created: 22, February 1998                                               *
  *                                                                          *
  * Version: 2.1                                                             *
  *                                                                          *
  * History                                                                  *
  * Version 2.1  03/10/98  Fix the bug that makes the color unchangeable     *
  *                        after a click on the control                      *
  *                                                                          *
  * Version 2.0  22/02/98  Initial freeware version                          *
  ****************************************************************************
  //IMPORTANT NOTICE :                                                      //
  //                                                                        //
  //                                                                        //
  //   This program is FreeWare                                             //
  //                                                                        //
  //  Please do not release modified versions of this source code.          //
  //  If you've made any changes that you think should have been there,     //
  //  feel free to submit them to me at carlosponce@eoi.es and I'll include //
  //  it (after test it) naming its author.                                  //

  It has been addes some properties to the TLabel component.

  property ImgControl    : TImage      Conected Control to TEtigraf. The
                                       property TPicture change when the mouse
                                       moves in (ImagenE) and moves out
                                       (ImagenS). It is optional

  property ImagenE       : TPicture    Image that ImgControl shows (property
                                       TPicture) when mouse moves in.

  property ImagenS       : TPicture    Idem, but when the mouse moves out.

  Property ColFondoAlEntrar: TColor    TEtiGraf background color when mouse
                                       moves in. When the mouse goes out, the
                                       background color is the indicated by the
                                       <<color>> property.

  Property FuenteAlEntrar  : TFont     TEtiGraf Font when mouse moves in. When
                                       the mouse goes out, the Font is the
                                       indicated by the <<Font>> property.

  Property Activa        : Boolean     When False, TEtiGraf woks as regular
                                       TLabel. When True, works as mentioned
                                       above.
}

unit Etigraf;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  Extctrls;

type
  TEtigraf = class(TLabel)
  private
    { Private declarations }
    FImgControl            : TImage;
    FImagenE, FImagenS     : TPicture;
    FColorOrig             : TColor;
    FFuenteOrig            : TFont;
    FColorFondoAlEntrar    : TColor;
    FFuenteEntrar          : TFont;
    FActiva,FRatonDentro   : Boolean;

    // Se utiliza para evita que se reasigne el color y la fuente original
    // cuando se hace click en el componente.

    // Used to avoid reassign the original font and color property when the
    // control receives a click.
    Primeravez             : Boolean;

    procedure SetImgControl(img: TImage);
    procedure SetImagenE(img: TPicture);
    procedure SetImagenS(img: TPicture);
    Procedure SetColorFondoAlEntrar(Color : Tcolor);
    Procedure SetFuente(Fuente: TFont);
    Procedure SetEtiquetaActiva(Valor: Boolean);
  protected
    { Protected declarations }
    Procedure WMMouseMove(var msg: TWMMouseMove);Message WM_MOUSEMOVE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property ImgControl    : TImage Read FImgControl Write SetImgControl;
    property ImagenE       : TPicture Read FImagenE Write SetImagenE;
    property ImagenS       : TPicture Read FImagenS Write SetImagenS;
    Property ColFondoAlEntrar: TColor Read FColorFondoAlEntrar Write SetColorFondoAlEntrar default clWindow;
    Property FuenteAlEntrar  : TFont READ FFuenteEntrar write SetFuente;
    Property Activa        : Boolean READ FActiva write SetEtiquetaActiva;
  end;

 procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('CPL', [TEtigraf]);
end;


constructor TEtigraf.Create(AOwner: TComponent);
begin
// Primero crea los elementos necesarios
// First create the necessary elements
  FFuenteOrig:= TFont.create;
  FFuenteEntrar:= TFont.create;
  FImagenE:= TPicture.create;
  FImagenS:= TPicture.create;
  Primeravez:= True;
  inherited Create(AOwner);
end;

destructor TEtigraf.Destroy;
begin
  FFuenteEntrar.free;
  FFuenteOrig.Free;
  FImagenE.free;
  FImagenS.free;
  inherited Destroy;
end;

Procedure TEtigraf.SetFuente(Fuente: TFont);
begin
  FFuenteEntrar.Assign(fuente);
end;

Procedure TEtigraf.SetEtiquetaActiva(Valor: Boolean);
begin
  FActiva := valor;
end;

procedure TEtigraf.SetImgControl(img: TImage);
begin
  FImgControl := img;
  if img <> nil then img.FreeNotification(Self);
end;

procedure TEtigraf.SetImagenE(img: TPicture);
begin
  FImagenE.Assign(img);
end;

procedure TEtigraf.SetImagenS(img: TPicture);
begin
  FImagenS.Assign(img);
end;

Procedure TEtigraf.SetColorFondoAlEntrar(Color : Tcolor);
Begin
  If FColorFondoAlEntrar <> Color Then FColorFondoAlEntrar := Color;
end;

Procedure TEtigraf.WMMouseMove(Var msg: TWMMouseMove);
Begin

  // Si la etiqueta est activa ...
  // If the Label is active ...
  if FActiva then
  begin

     // Si pasa por aqui, es porque el ratn ha entrado (se ha movido) en el
     // control sin que este sea el control activo del formulario. Se genera un
     // WM_MOUSEMOVE, pero al no ser el control activo..
     // ... no le llegan los mensajes del ratn

     // If reach this point, the mouse enter (it was moved to) on the component
     // and this is not the active control on the form. It create a WM_MOUSEMOVE
     // but as this is not the active control...
     // ... the mouse messages not reach the component (TEtigraf)
     If not MouseCapture then
     begin

        // Me aseguro de capturar los mensajes del ratn (para saber si sale)
        // haciendo que sea este el control donde llegan.

        // I need to capture the mouse messages (to know when it leaves the
        // label), making this control the one where the messages arrive.
        SetCaptureControl(Self);

        // Si la ventana padre est activa, puedo proceder.

        // If the parent form is active, I can go on.
        If Enabled and Visible and getParentForm(Self).Active then
        begin
           // Primero guardo el color y la fuente originales

           // First, I store the originals color and Font
           if Primeravez then
           begin
              FColorOrig:= Color;
              FFuenteOrig.Assign(Font);
              Primeravez:= False;
           end;

           // Ahora los cambio.

           // Now, change them.
           Color := FColorFondoAlEntrar;
           Font.Assign(FFuenteEntrar);

           // Si no est asignado el TImage, no hago nada.
           // Si lo est, asigno su propiedad TPicture con la imagen al entrar.

           // If there is no TImage assigned, I make nothing.
           // If it is, I assign the TPicture property with the image when
           // enter.
           if ImgControl<> nil then ImgControl.Picture:= FImagenE;
        End;
     End;

     // Si el ratn se ha movido (ha llegado un WM_MOUSEMOVE), pero no est
     // dentro del control, es porque se ha salido ...

     // If the mouse moves (a WM_MOUSEMOVE has arrived), but it is out of the
     // control, it's due to the mouse leaves the control ...
     If MouseCapture and ((msg.xpos < 0) or (msg.ypos < 0) or (msg.xPos >
        Width) or (msg.Ypos > Height)) and FRatonDentro Then
     begin
        FRatonDentro := False;
        // Vuelvo a poner el color y la fuente originales.

        // I restore the originals color and font.
        Color := FColorOrig;
        Font.Assign(FFuenteOrig);

        // Si tiene asignado un TImage, pongo la Imagen de salida.

        // If there is a TImage assigned, I present the image when leave.
        if ImgControl <> nil then ImgControl.Picture:= FImagenS;

        // Ahora ya no es necesario que capture los sucesos del ratn.

        // Now, is not necessary to capture the mouse events.
        SetCaptureControl(Nil);
     end;

     // ...Si llega aqui, es porque se ha movido dentro del control.
     // Cuando entra por primera vez, siempre pasa por aqui despus del
     // <<if not MouseCapture>>

     // ...If reach this point, the mouse moves into the control. Always reach
     // this point when it enter the first time, after the
     // <<if not MouseCapture>>
     If MouseCapture and ((msg.xpos >= 0) and (msg.ypos >= 0) and (msg.xPos <=
        Width) and (msg.Ypos <= Height)) and not FRatonDentro then
     begin
        FRatonDentro := True;
     end;
  end;
end;

End.
